// FILENAME:  MercsInc.cs
//
// AUTHORS:    Orogogus
//------------------------------------------------------------------------------

$missionName = "Mercenaries, Inc.";

exec("multiplayerStdLib.cs");

function setDefaultMissionOptions()
{
  $server::TeamPlay = true;
  $server::AllowDeathmatch = false;
  $server::AllowTeamPlay = true;  

   // what can the client choose for a team
  $server::AllowTeamRed = false;
  $server::AllowTeamBlue = true;
  $server::AllowTeamYellow = false;
  $server::AllowTeamPurple = false;

  // what can the server admin choose for available teams
  $server::disableTeamRed = true;
  $server::disableTeamBlue = false;
  $server::disableTeamYellow = true;
  $server::disableTeamPurple = true;
}


function onMissionStart()
{
}


function onMissionLoad()
{
  $MissionCycling::Stage0 = "MercsInc";
  $MIcurrentMission = 0;
  $MIreadyToLaunch = 0;

  exec("MercsIncPlayerList.cs");
  exec("MercsIncMissionList.cs");
}

function player::OnAdd(%player)
{
  %player.MIloggedIn = 0;
  %player.MIstartMission = 0;
}

function vehicle::OnAdd(%vehicle)
{
  %player = playerManager::VehicleIdToPlayerNum(%vehicle);
  %player.MIstartMission = 0;
}


//======================================


function Mercs::checkPlayerName(%player, %password)
{

  %nameMatch = 0;
  %tempMIPlayers = $MIPlayers + 1;

  for(%i=1; %i<%tempMIPlayers; %i++)
  {

    %checkNameA = "$MIPlayer";
    %checkNameB = %i;
    %checkNameC = %checkNameA @ %checkNameB; 
    eval("%checkName = " @ %checkNameC @ ";");   // string trickery to avoid messy arrays

    if(getName(%player) == %checkName)
    {
      %nameMatch = 1;

      %checkPasswordA = "$MIPlayerPassword";
      %checkPasswordB = %i;
      %checkPasswordC = %checkPasswordA @ %checkPasswordB; 
      eval("%checkPassword = " @ %checkPasswordC @ ";");

      if(%password != %checkPassword)
      {
        messagebox(%player, "Sorry, your password doesn't match your name! " @ 
          "Either someone has already registered this name " @
          "or your password is incorrectly configured.  " @ 
          "Please report on the Editing and Scripting board.  Thank you, and enjoy your visit.");
      }
      else
      {
        eval( "%player.MImoney = $MIPlayerMoney" @ %i @ ";");
        %player.MIloggedIn = 1;
        %player.MIid = %i;
        say(%player, 0, "Welcome back, " @ getName(%player) @ ".  Your account is $" @ %player.MImoney @ ".");

        if($MIreadyToLaunch == 1) Mercs::startCheck2();
      }
    }
  }

  if(%nameMatch == 0)    // sign up a new player
  {
    $MIPlayers++;
    eval("$MIPlayer" @ $MIPlayers @ " = \"" @ getName(%player) @ "\";");
    eval("$MIPlayerPassword" @ $MIPlayers @ " = " @ %password @ ";");
    Mercs::inscribeRecord();
    %player.MIid = %i;

    messagebox(%player, "Welcome to Mercenaries, Inc.  Please excuse the dust.");
    %player.MImoney = 0;
    %player.MIloggedIn = 1;
    Mercs::addMoney(%player, 0);

    if($MIreadyToLaunch == 1) Mercs::startCheck2();
  }
}


function Mercs::addMoney(%player, %money)
{
  %player.MImoney = %player.MImoney + %money;
  eval("$MIPlayerMoney" @ %player.MIid @ " = " @ %player.MImoney @ ";");  
  Mercs::inscribeRecord();
}


function Mercs::inscribeRecord()
{
  export("$MIPlayer*", "multiplayer\\MercsIncPlayerList.cs", False);
}


function Mercs::launchMission()
{
  $MIreadyToLaunch = 2;
  say(0, 0, "Selection locked.  Mission launches in 5 seconds.");
  schedule("missionEndConditionMet();", 5);
}


function Mercs::selectNextMission()
{
  $MIcurrentMission++;
  if($MIcurrentMission > $MImissionCount) $MIcurrentMission = 1;

  eval("$MissionCycling::Stage0 = $MImission" @ $MIcurrentMission @ ";");

  eval("$MIlocation = $MImissionLocation" @ $MIcurrentMission @ ";");
  eval("$MItype = $MImissionType" @ $MIcurrentMission @ ";");

  eval("$MIbountyPercent = $MImissionBountyPercent" @ $MIcurrentMission @ ";");
  eval("$MIdifficulty = $MImissionDifficulty" @ $MIcurrentMission @ ";");  
  eval("$MItransportPercent = $MImissionTransportPercent" @ $MIcurrentMission @ ";");
  eval("$MItotalPay = $MImissionPay" @ $MIcurrentMission @ ";");
  eval("$MIpayUpFront = $MImissionPayUpFront" @ $MIcurrentMission @ ";");

  %bounty = round($MIbountyPercent * 1000) / 10;
  %transport = round($MItransportPercent * 1000) / 10;

  say(0, 0, "Selected mission: " @ $MIlocation @ " (" @ $MItype @ "), difficulty " @ $MIdifficulty @ 
        ".  Total pay: $" @ $MItotalPay @ " ($" @ $MIpayUpFront @ " up front), " @ %bounty @ "% kill bounty less " @
        %transport @ "% transport fees");
}


function Mercs::startCheck(%player)  // when someone sets the mission
{
  %ready = 1;
  %waitingFor = 0;

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player2 = playerManager::getPlayerNum(%i);
    if(%player2.MIloggedIn != 1)
    {
      %ready = 0;
      say(%player2, 0, "WARNING: Someone has initiated a mission selection, and you are not logged in.  Please log in now if you want to join this mission.");
      %waitingFor++;
    }
  }

  if(%ready == 0)
  {
    say(%player, 0, "WARNING: " @ %waitingFor @ " players have not logged in yet.  Please confirm that you want to launch this mission without them.");
  }
  else Mercs::launchMission();
}


function Mercs::startCheck2(%player)   // when someone logs in after the mission has been set
{
  %ready = 1;
  %waitingFor = 0;

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    if(%player.MIloggedIn != 1)
    {
      %ready = 0;
      %waitingFor++;
    }
  }

  if(%ready == 0)
  {
    say(0, 0, getName(%player) @ " has logged in.  Waiting for " @ %waitingFor @ " more players.");
  }
  else
  {
    say(0, 0, "All players logged in.");
    Mercs::launchMission();
  }
}



//================================

function remoteMercs::Login(%player, %password)
{
  if(%player.MIloggedIn == 1) say(%player, 0, "You are already logged in, " @ getName(%player) @ ".  Your account is $" @ %player.MImoney @ ".");
   else Mercs::checkPlayerName(%player, %password);
}

//================================



function missionSelect::structure::OnScan(%scannee, %scanner, %string)
{
  if($MIreadyToLaunch == 2) return;
  Mercs::selectNextMission();
}


function missionSelect::structure::OnAttacked(%target, %attacker)
{
  if($MIreadyToLaunch == 2) return;
  %player = playerManager::vehicleIdToPlayerNum(%attacker);

  if($MIcurrentMission == 0)
  {
    say(%player, 0, "Please select a mission by scanning the structure first.");
    return;
  }

  if($MIreadyToLaunch == 1)
  {
    Mercs::launchMission();
    return;
  }
  else if($MIreadyToLaunch == 0)
  {
    $MIreadyToLaunch = 1;
    Mercs::startCheck(%player);
  }
}


function changeMission::trigger::OnContact(%this, %vehicleId)
{
}



//======================


function round(%number)
{
   %roundNum = %number;
   if(%number > 0)
   {
      %excess = (%number - floor(%number));
      if(%excess >= 0.5)
      {
         %roundNum = (floor(%number) + 1);
      }
      else
      {
         %roundNum = floor(%number);
      }
   }
   if(%number < 0)
   {
      %excess = (floor(%number) - %number);
      if(%excess <= 0.5)
      {
         %roundNum = floor(%number);
      }
      else
      {
         %roundNum = (floor(%number) - 1);
      }
   }
   return %roundNum;
}